"""
    FactSet Concordance API

      The FactSet Concordance API enables Application Developers and Data Scientists to programmatically discover the FactSet Identifier for a specific Entity or Person based on attributes, such as name, URL, and location.FactSet Identifiers are mapped to industry-standard identifiers, as well as to a comprehensive set of reference data and unique content, to enhance the ability to quickly connect content sets.<p>     Using the submitted attributes, the FactSet Concordance API leverages FactSet’s extensive Entity Master, People, and Symbology databases to return potential candidate matches and a proposed match. The result is a concorded FactSet Identifier that can then be used as input throughout FactSet's expanding catalog of Content using our Content APIs or Standard DataFeeds.</p>    <b>There are two types of workflows supported in the API:</b>    <b>Entity & People Match:</b> The first workflow follows traditional API conventions in that a request is accepted and a response is returned synchronously enabling the concordance of up to 25 names in a single request. The response returns a list of 20 candidates as well as a proposed match.    <b>Entity & People Match - Bulk:</b> The second workflow allows you to input a large list of names within a .CSV file in a single request With this workflow, a task is created for uploading a set of queries. Once the task has completed, the client retrieves the concordance results through the /entity-decisions or /people-decisions endpoint. Note that in the Bulk workflow, only the matches for the records are returned. Candidates are not included.    Once the service has provided a list of concorded FactSet Identifiers, you can then use our Entity Mappings and People Mappings endpoints to further review the universe of mapped identifiers or modify existing records. </p>     # noqa: E501

    The version of the OpenAPI document: 2.8.0
    Contact: api@factset.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from fds.sdk.FactSetConcordance.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from fds.sdk.FactSetConcordance.exceptions import ApiAttributeError



class EntityMappingRequest(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
        ('client_country',): {
            'max_length': 2,
            'min_length': 2,
        },
        ('client_state',): {
            'max_length': 2,
            'min_length': 2,
        },
        ('client_additional_context',): {
            'max_items': 5,
            'max_properties': 5,
        },
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        return {
            'universe_id': (int,),  # noqa: E501
            'client_id': (str,),  # noqa: E501
            'client_name': (str,),  # noqa: E501
            'entity_id': (str,),  # noqa: E501
            'client_country': (str,),  # noqa: E501
            'client_state': (str,),  # noqa: E501
            'client_url': (str,),  # noqa: E501
            'client_bbg_figi': (str,),  # noqa: E501
            'client_bbg_ticker': (str,),  # noqa: E501
            'client_bic': (str,),  # noqa: E501
            'client_cik': (str,),  # noqa: E501
            'client_crd': (str,),  # noqa: E501
            'client_cusip': (str,),  # noqa: E501
            'client_duns': (str,),  # noqa: E501
            'client_ein': (str,),  # noqa: E501
            'client_factset_id': (str,),  # noqa: E501
            'client_fitch': (str,),  # noqa: E501
            'client_gvkey_iid': (str,),  # noqa: E501
            'client_gvkey': (str,),  # noqa: E501
            'client_isin': (str,),  # noqa: E501
            'client_jcn': (str,),  # noqa: E501
            'client_lei': (str,),  # noqa: E501
            'client_lxid': (str,),  # noqa: E501
            'client_md': (str,),  # noqa: E501
            'client_ticker': (str,),  # noqa: E501
            'client_priority': (str,),  # noqa: E501
            'client_red_code': (str,),  # noqa: E501
            'client_rssd': (str,),  # noqa: E501
            'client_sedol': (str,),  # noqa: E501
            'client_spr': (str,),  # noqa: E501
            'client_ticker_exchange': (str,),  # noqa: E501
            'client_ticker_region': (str,),  # noqa: E501
            'client_ukch': (str,),  # noqa: E501
            'client_valoren': (str,),  # noqa: E501
            'client_wkn': (str,),  # noqa: E501
            'client_additional_context': ({str: (str,)},),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'universe_id': 'universeId',  # noqa: E501
        'client_id': 'clientId',  # noqa: E501
        'client_name': 'clientName',  # noqa: E501
        'entity_id': 'entityId',  # noqa: E501
        'client_country': 'clientCountry',  # noqa: E501
        'client_state': 'clientState',  # noqa: E501
        'client_url': 'clientUrl',  # noqa: E501
        'client_bbg_figi': 'clientBbgFigi',  # noqa: E501
        'client_bbg_ticker': 'clientBbgTicker',  # noqa: E501
        'client_bic': 'clientBic',  # noqa: E501
        'client_cik': 'clientCik',  # noqa: E501
        'client_crd': 'clientCrd',  # noqa: E501
        'client_cusip': 'clientCusip',  # noqa: E501
        'client_duns': 'clientDuns',  # noqa: E501
        'client_ein': 'clientEin',  # noqa: E501
        'client_factset_id': 'clientFactsetId',  # noqa: E501
        'client_fitch': 'clientFitch',  # noqa: E501
        'client_gvkey_iid': 'clientGvkeyIid',  # noqa: E501
        'client_gvkey': 'clientGvkey',  # noqa: E501
        'client_isin': 'clientIsin',  # noqa: E501
        'client_jcn': 'clientJcn',  # noqa: E501
        'client_lei': 'clientLei',  # noqa: E501
        'client_lxid': 'clientLxid',  # noqa: E501
        'client_md': 'clientMd',  # noqa: E501
        'client_ticker': 'clientTicker',  # noqa: E501
        'client_priority': 'clientPriority',  # noqa: E501
        'client_red_code': 'clientRedCode',  # noqa: E501
        'client_rssd': 'clientRssd',  # noqa: E501
        'client_sedol': 'clientSedol',  # noqa: E501
        'client_spr': 'clientSpr',  # noqa: E501
        'client_ticker_exchange': 'clientTickerExchange',  # noqa: E501
        'client_ticker_region': 'clientTickerRegion',  # noqa: E501
        'client_ukch': 'clientUkch',  # noqa: E501
        'client_valoren': 'clientValoren',  # noqa: E501
        'client_wkn': 'clientWkn',  # noqa: E501
        'client_additional_context': 'clientAdditionalContext',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, universe_id, client_id, client_name, *args, **kwargs):  # noqa: E501
        """EntityMappingRequest - a model defined in OpenAPI

        Args:
            universe_id (int): The universe to save this mapping to.
            client_id (str): A unique identifier supplied by the user. ClientId is saved to the user's Concordance universe and will be used as the identifier for that entity within the universe.
            client_name (str): Name of entity to match.

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            entity_id (str): FactSet Entity Identifier mapped to the submitted entity.. [optional]  # noqa: E501
            client_country (str): ISO2 country code corresponding to the Entity name.. [optional]  # noqa: E501
            client_state (str): ISO Code of State or Province location to map Entity.. [optional]  # noqa: E501
            client_url (str): URL corresponding to the entity name.. [optional]  # noqa: E501
            client_bbg_figi (str): User provided input for Bloomberg Listing/Regional/Security ID symbol type.. [optional]  # noqa: E501
            client_bbg_ticker (str): User provided input for Bloomberg Listing and Regional Ticker symbol type.. [optional]  # noqa: E501
            client_bic (str): User provided input for BICCode, bank indentification code symbol type.. [optional]  # noqa: E501
            client_cik (str): User provided input for CIK, Edgar Central Index Keys symbol type.. [optional]  # noqa: E501
            client_crd (str): User provided input for CRD, Central Registration Depository symbol type.. [optional]  # noqa: E501
            client_cusip (str): User provided input for CUSIP symbol type.. [optional]  # noqa: E501
            client_duns (str): User provided input for DUNS, Dun&Bradstreet symbol type.. [optional]  # noqa: E501
            client_ein (str): User provided input for EmployerIdentificationNumber, EIN symbol type.. [optional]  # noqa: E501
            client_factset_id (str): User provided input for FactSet Identifier, FactSet -E,-S,-R, -L Permanent Identifier symbol type.. [optional]  # noqa: E501
            client_fitch (str): User provided input for FitchCreditRating, Fitch Ratings Identifier symbol type.. [optional]  # noqa: E501
            client_gvkey_iid (str): User provided input for GVKEY+IID, Compustat Global Company Key and Issue Identifier symbol type.. [optional]  # noqa: E501
            client_gvkey (str): User provided input for GVKEY, Compustat Global Company Key symbol type.. [optional]  # noqa: E501
            client_isin (str): User provided input for ISIN symbol type.. [optional]  # noqa: E501
            client_jcn (str): User provided input for JCN , Japanese Corporate Number symbol type.. [optional]  # noqa: E501
            client_lei (str): User provided input for LegalEntityIdentifier, LEI symbol type.. [optional]  # noqa: E501
            client_lxid (str): User provided input for LXID, Markit Syndicated Loan Identifier symbol type.. [optional]  # noqa: E501
            client_md (str): User provided input for MoodysIssuer, Moody's Ratings Identifier symbol type.. [optional]  # noqa: E501
            client_ticker (str): User provided input for PriceTicker symbol type.. [optional]  # noqa: E501
            client_priority (str): Name of the priority column as provided by the user.. [optional]  # noqa: E501
            client_red_code (str): User provided input for RedCode, Markit Reference Entity Identifier symbol type.. [optional]  # noqa: E501
            client_rssd (str): User provided input for FederalReserveRSSDIdentifier, RSSD symbol type.. [optional]  # noqa: E501
            client_sedol (str): User provided input for SEDOL symbol type.. [optional]  # noqa: E501
            client_spr (str): User provided input for S&PRating, S&P Ratings Identifier.. [optional]  # noqa: E501
            client_ticker_exchange (str): User provided input for TickerExch symbol type.. [optional]  # noqa: E501
            client_ticker_region (str): User provided input for TickerRegion symbol type. [optional]  # noqa: E501
            client_ukch (str): User provided input for UKCompanyHouse symbol type. [optional]  # noqa: E501
            client_valoren (str): User provided input for VALOR, Valoren (\"Valor\") Identification symbol type.. [optional]  # noqa: E501
            client_wkn (str): User provided input for WKN, German Securities Identification symbol type.. [optional]  # noqa: E501
            client_additional_context ({str: (str,)}): Any additional context information that can be saved along with other input values for mapping. To be used by Managed Service for mapping any unmapped records.  . [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.universe_id = universe_id
        self.client_id = client_id
        self.client_name = client_name
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, universe_id, client_id, client_name, *args, **kwargs):  # noqa: E501
        """EntityMappingRequest - a model defined in OpenAPI

        Args:
            universe_id (int): The universe to save this mapping to.
            client_id (str): A unique identifier supplied by the user. ClientId is saved to the user's Concordance universe and will be used as the identifier for that entity within the universe.
            client_name (str): Name of entity to match.

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            entity_id (str): FactSet Entity Identifier mapped to the submitted entity.. [optional]  # noqa: E501
            client_country (str): ISO2 country code corresponding to the Entity name.. [optional]  # noqa: E501
            client_state (str): ISO Code of State or Province location to map Entity.. [optional]  # noqa: E501
            client_url (str): URL corresponding to the entity name.. [optional]  # noqa: E501
            client_bbg_figi (str): User provided input for Bloomberg Listing/Regional/Security ID symbol type.. [optional]  # noqa: E501
            client_bbg_ticker (str): User provided input for Bloomberg Listing and Regional Ticker symbol type.. [optional]  # noqa: E501
            client_bic (str): User provided input for BICCode, bank indentification code symbol type.. [optional]  # noqa: E501
            client_cik (str): User provided input for CIK, Edgar Central Index Keys symbol type.. [optional]  # noqa: E501
            client_crd (str): User provided input for CRD, Central Registration Depository symbol type.. [optional]  # noqa: E501
            client_cusip (str): User provided input for CUSIP symbol type.. [optional]  # noqa: E501
            client_duns (str): User provided input for DUNS, Dun&Bradstreet symbol type.. [optional]  # noqa: E501
            client_ein (str): User provided input for EmployerIdentificationNumber, EIN symbol type.. [optional]  # noqa: E501
            client_factset_id (str): User provided input for FactSet Identifier, FactSet -E,-S,-R, -L Permanent Identifier symbol type.. [optional]  # noqa: E501
            client_fitch (str): User provided input for FitchCreditRating, Fitch Ratings Identifier symbol type.. [optional]  # noqa: E501
            client_gvkey_iid (str): User provided input for GVKEY+IID, Compustat Global Company Key and Issue Identifier symbol type.. [optional]  # noqa: E501
            client_gvkey (str): User provided input for GVKEY, Compustat Global Company Key symbol type.. [optional]  # noqa: E501
            client_isin (str): User provided input for ISIN symbol type.. [optional]  # noqa: E501
            client_jcn (str): User provided input for JCN , Japanese Corporate Number symbol type.. [optional]  # noqa: E501
            client_lei (str): User provided input for LegalEntityIdentifier, LEI symbol type.. [optional]  # noqa: E501
            client_lxid (str): User provided input for LXID, Markit Syndicated Loan Identifier symbol type.. [optional]  # noqa: E501
            client_md (str): User provided input for MoodysIssuer, Moody's Ratings Identifier symbol type.. [optional]  # noqa: E501
            client_ticker (str): User provided input for PriceTicker symbol type.. [optional]  # noqa: E501
            client_priority (str): Name of the priority column as provided by the user.. [optional]  # noqa: E501
            client_red_code (str): User provided input for RedCode, Markit Reference Entity Identifier symbol type.. [optional]  # noqa: E501
            client_rssd (str): User provided input for FederalReserveRSSDIdentifier, RSSD symbol type.. [optional]  # noqa: E501
            client_sedol (str): User provided input for SEDOL symbol type.. [optional]  # noqa: E501
            client_spr (str): User provided input for S&PRating, S&P Ratings Identifier.. [optional]  # noqa: E501
            client_ticker_exchange (str): User provided input for TickerExch symbol type.. [optional]  # noqa: E501
            client_ticker_region (str): User provided input for TickerRegion symbol type. [optional]  # noqa: E501
            client_ukch (str): User provided input for UKCompanyHouse symbol type. [optional]  # noqa: E501
            client_valoren (str): User provided input for VALOR, Valoren (\"Valor\") Identification symbol type.. [optional]  # noqa: E501
            client_wkn (str): User provided input for WKN, German Securities Identification symbol type.. [optional]  # noqa: E501
            client_additional_context ({str: (str,)}): Any additional context information that can be saved along with other input values for mapping. To be used by Managed Service for mapping any unmapped records.  . [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.universe_id = universe_id
        self.client_id = client_id
        self.client_name = client_name
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
